//
//  ProfileViewController.swift
//  VKExt
//
//  Created programmist_NA on 25.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import Material
import MaterialComponents
import SideMenu
import Serrata
import SwiftMessages
import PanModal

class ProfileViewController: UIBaseTableViewController, UIBaseViewControllerProtocol, UIBaseTableViewControllerProtocol, ProfileViewProtocol {
    static let blurView: UIVisualEffectView = {
        let view = UIVisualEffectView(effect: UIBlurEffect(style: .regular))
        view.autoresizingMask = .flexibleWidth
        return view
    }()
    var presenter: ProfilePresenterProtocol?
    var userId: Int = VKConstants.currentUserId
    private var profileViewModel = ProfileViewModel.init(cell: nil, footerTitle: nil)
    private var photosViewModel = PhotoViewModel.init(cell: [], footerTitle: nil)
    private var wallViewModel = FeedViewModel.init(cells: [], footerTitle: nil)
    private lazy var footerView = FooterView()
    var qrScanerButton: IconButton = {
        let button = IconButton(image: UIImage(named: "qr_code_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        return button
    }()
    var settingsButton: IconButton = {
        let button = IconButton(image: UIImage(named: "menu_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        button.addTarget(self, action: #selector(openScreen), for: .touchUpInside)
        return button
    }()
    var backButton: IconButton = {
        let button = IconButton(image: UIImage(named: "arrow_left_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        button.addTarget(self, action: #selector(dismiss), for: .touchUpInside)
        return button
    }()
    var moreButton: IconButton = {
        let button = IconButton(image: UIImage(named: "more_horizontal_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        return button
    }()
    var settingsController: SideMenuNavigationController?
    let fab: MDCFloatingButton = {
        let fab = MDCFloatingButton(shape: .default)
        fab.setImage(UIImage(named: "write_outline_28"), for: .normal)
        fab.backgroundColor = UIColor.adaptableWhite.withAlphaComponent(0.82)
        fab.layer.backgroundColor = UIColor.adaptableWhite.withAlphaComponent(0.82).cgColor
        fab.setBorderWidth(0.5, for: .normal)
        fab.setBorderColor(.adaptableDivider, for: .normal)
        fab.setElevation(.none, for: .normal)
        // fab.addTarget(self, action: #selector(scrollToLast), for: .touchUpInside)
        return fab
    }()
    var forbiddenView = ForbiddenView(frame: CGRect(origin: .zero, size: CGSize(width: screenWidth - 32, height: screenHeight / 2)))

    convenience init(userId: Int) {
        self.init()
        self.userId = userId
        ProfileRouter.createModule(self)
        presenter?.start(request: .getProfileFirstInfo(userId: userId))
        presenter?.start(request: .getProfileSecondInfo(userId: userId))
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.view.backgroundColor = .adaptableWhite
        ProfileRouter.createModule(self)
        presenter?.start(request: .getProfileFirstInfo(userId: userId))
        presenter?.start(request: .getProfileSecondInfo(userId: userId))
        prepareTable()
        setupTable()
        prepareToolbar(fonts: [GoogleSansFont.bold(with: 21), GoogleSansFont.regular(with: 13)])
        setupFab()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        devView.devAnimationImage.play()
    }
    
    func setupFab() {
        tableView.addSubview(fab)
        fab.isHidden = true
        fab.autoPinEdge(.bottom, to: .bottom, of: tableView, withOffset: -getCommonInset(by: [.tabbar]) - 16)
        fab.autoPinEdge(.trailing, to: .trailing, of: tableView, withOffset: -16)
        fab.clipsToBounds = true
        blurView.frame = fab.bounds
        fab.insertSubview(blurView, at: 0)
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) {
//        toolbar.dividerColor = .adaptableDivider
//        toolbar.dividerContentEdgeInsets = UIEdgeInsets(top: 0, left: 12, bottom: 0, right: 12)
        toolbar.title = title
        toolbar.detail = subtitle
        if let leftViews = leftViews {
            toolbar.leftViews = leftViews
        }
        if let rightViews = rightViews {
            toolbar.rightViews = rightViews
        }
    }
    
    func setupSettingsController() {
        settingsController = SideMenuNavigationController(rootViewController: MessageSettingsViewController(toolbarTitle: "\(profileViewModel.cell!.firstName!) \(profileViewModel.cell!.lastName!)"))
        guard let settingsController = settingsController else { return }
        SideMenuManager.default.rightMenuNavigationController = settingsController
        SideMenuManager.default.addPanGestureToPresent(toView: view)
        SideMenuManager.default.addScreenEdgePanGesturesToPresent(toView: view, forMenu: .right)
        settingsController.presentationStyle = .viewSlideOutMenuIn
        settingsController.presentationStyle.presentingEndAlpha = 0.5
        settingsController.presentDuration = 0.3
        settingsController.dismissDuration = 0.3
        settingsController.enableSwipeToDismissGesture = true
        settingsController.presentationStyle.backgroundColor = .adaptableBackground
        settingsController.menuWidth = screenWidth - (screenWidth / 7)
        settingsController.statusBarEndAlpha = 0
    }
    
    @objc func openScreen() {
        guard let settingsController = settingsController else { return }
        present(settingsController, animated: true, completion: nil)
    }
    
    // Настройка таблицы
    func setupTable() {
        topOffset?.constant = getCommonInset(by: [.statusbar, .toolbar]) + 8
        mainTable.backgroundColor = .adaptableWhite
        mainTable.register(UINib(nibName: "ProfileFristCell", bundle: nil), forCellReuseIdentifier: "ProfileFristCell")
        mainTable.register(UINib(nibName: "ProfileFirstAnotherCell", bundle: nil), forCellReuseIdentifier: "ProfileFirstAnotherCell")
        mainTable.register(UINib(nibName: "ProfileSecondCell", bundle: nil), forCellReuseIdentifier: "ProfileSecondCell")
        mainTable.register(UINib(nibName: "ClosedProfileCell", bundle: nil), forCellReuseIdentifier: "ClosedProfileCell")
        mainTable.register(PhotoProfileCell.self, forCellReuseIdentifier: PhotoProfileCell.reuseId)
        mainTable.register(NewsFeedCell.self, forCellReuseIdentifier: NewsFeedCell.reuseId)
        mainTable.tableFooterView = footerView
        mainTable.keyboardDismissMode = .onDrag
        mainTable.allowsMultipleSelection = false
        mainTable.allowsMultipleSelectionDuringEditing = true
        mainTable.separatorStyle = .none
        mainTable.delegate = self
        mainTable.dataSource = self
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: .valueChanged)
    }
    
    func displayData(viewModel: ProfileModel.ViewModel.ViewModelData) {
        switch viewModel {
        case .displayProfileFirstInfo(profileViewModel: let profileViewModel):
            self.profileViewModel = profileViewModel
            fab.isHidden = !profileViewModel.cell!.canPost!
            toolbar.dividerThickness = profileViewModel.cell!.isClosed! ? 0 : 0.4
            mainTable.reloadData()
            refreshControl.endRefreshing()
            if profileViewModel.cell?.isCurrentProfile ?? true {
                setupToolbar(title: profileViewModel.cell!.screenName!, subtitle: "", leftViews: [qrScanerButton], rightViews: [settingsButton])
                setupSettingsController()
            } else {
                setupToolbar(title: profileViewModel.cell!.screenName!, subtitle: "", leftViews: [backButton], rightViews: [moreButton])
            }
            if profileViewModel.cell!.blacklisted! {
                blacklistedUser()
            }
            guard profileViewModel.cell!.canAccessClosed! && !profileViewModel.cell!.blacklisted! else {
                footerView.setTitle("")
                return
            }
            presenter?.start(request: .getProfilePhotos(userId: userId))
            presenter?.start(request: .getProfileWall(userId: userId))
        case .displayProfileSecondInfo(profileViewModel: let profileViewModel):
            self.profileViewModel = profileViewModel
            mainTable.reloadData()
            refreshControl.endRefreshing()
        case .displayProfilePhotos(profileViewModel: let photosViewModel):
            self.photosViewModel = photosViewModel
            mainTable.reloadData()
            refreshControl.endRefreshing()
        case .displayWall(wallViewModel: let wallViewModel):
            self.wallViewModel = wallViewModel
            footerView.setTitle(wallViewModel.footerTitle)
            mainTable.reloadData()
            refreshControl.endRefreshing()
            let wallItemsCount = wallViewModel.cells.count > 0 ? "\(wallViewModel.cells.count) \(getStringByDeclension(number: wallViewModel.cells.count, arrayWords: Localization.instance.wallsCount))" : "Нет записей"
            footerView.setTitle(wallItemsCount)
        case .displayFooterLoader:
            footerView.setTitle("")
            footerView.showLoader()
            mainTable.sectionHeaderHeight = 0
        case .displayFooterError(message: let message):
            toolbar.title = "Ошибка загрузки"
            footerView.setTitle(message)
            mainTable.reloadData()
            refreshControl.endRefreshing()
        }
    }
    
    func blacklistedUser() {
//        forbiddenView.message = """
//        Пользователь внес Вас в черный список
//        ЪУЪ
//
//        """
        var config = SwiftMessages.Config()
        config.presentationStyle = .center
        config.presentationContext = .view(mainTable)
        config.duration = .forever
        config.dimMode = .blur(style: .regular, alpha: 1, interactive: true)
        config.interactiveHide = false
        config.preferredStatusBarStyle = .default
        SwiftMessages.show(config: config, view: forbiddenView)
    }
    
    func initialFooter() {
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: .valueChanged)
        self.view.addSubview(devView)
        devView.autoCenterInSuperview()
        devView.setup(page: "\"Профиль\"", animation: "development")
        devView.devAnimationImage.loopMode = .playOnce
        devView.devAnimationImage.play()
    }
    
    @objc func refreshTable(_ sender: Any?) {
        presenter?.start(request: .getProfileFirstInfo(userId: userId))
        presenter?.start(request: .getProfileSecondInfo(userId: userId))
    }
    
    // MARK: NewsfeedCodeCellDelegate
    
    func revealPost(for cell: NewsFeedCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let cellViewModel = wallViewModel.cells[indexPath.row]
        if let repost = cellViewModel.repost?.first {
            presenter?.start(request: .revealPostIds(postId: repost.id))
        } else {
            presenter?.start(request: .revealPostIds(postId: cellViewModel.postId))
        }
    }
    
    func likePost(for cell: NewsFeedCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let count = wallViewModel.cells[indexPath.row].likes?.intValue
        let newCount = (count ?? 0) + 1
        wallViewModel.cells[indexPath.row].likes = newCount.stringValue
        wallViewModel.cells[indexPath.row].userLikes = 1
        cell.set(viewModel: wallViewModel.cells[indexPath.row])
        presenter?.onLikePost(request: .like(postId: wallViewModel.cells[indexPath.row].postId, sourceId: wallViewModel.cells[indexPath.row].sourceId, type: wallViewModel.cells[indexPath.row].type))
    }
    
    func unlikePost(for cell: NewsFeedCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let count = wallViewModel.cells[indexPath.row].likes?.intValue
        let newCount = (count ?? 0) - 1
        wallViewModel.cells[indexPath.row].likes = newCount == 0 ? "" : newCount.stringValue
        wallViewModel.cells[indexPath.row].userLikes = 0
        cell.set(viewModel: wallViewModel.cells[indexPath.row])
        presenter?.onLikePost(request: .unlike(postId: wallViewModel.cells[indexPath.row].postId, sourceId: wallViewModel.cells[indexPath.row].sourceId, type: wallViewModel.cells[indexPath.row].type))
    }
}
extension ProfileViewController: UITableViewDelegate, UITableViewDataSource, NewsFeedCellDelegate, ProfileDelegate {
    func scrollViewDidEndDragging(_ scrollView: UIScrollView, willDecelerate decelerate: Bool) {
        if scrollView.contentOffset.y > scrollView.contentSize.height / 1.1 {
            presenter?.start(request: .getNextBatch(userId: userId))
        }
    }

    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        guard let cellViewModel = profileViewModel.cell else { return 0 }
        switch section {
        case 0:
            return 1
        case 1:
            return getRowsCount(by: cellViewModel)
        case 2:
            return 1
        case 3:
            return wallViewModel.cells.count
        default:
            return 0
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            guard let cellViewModel = profileViewModel.cell else { return UITableViewCell() }
            if cellViewModel.id == VKConstants.currentUserId {
                let cell = tableView.dequeueReusableCell(withIdentifier: "ProfileFristCell", for: indexPath) as! ProfileFristCell
                cell.set(viewModel: cellViewModel)
                cell.tag = indexPath.row
                cell.delegate = self
                return cell
            } else {
                let cell = tableView.dequeueReusableCell(withIdentifier: "ProfileFirstAnotherCell", for: indexPath) as! ProfileFirstAnotherCell
                cell.set(viewModel: cellViewModel)
                cell.delegate = self
                return cell
            }
        case 1:
            guard let cellViewModel = profileViewModel.cell, !cellViewModel.blacklisted! else { return UITableViewCell() }
            let cell = tableView.dequeueReusableCell(withIdentifier: "ProfileSecondCell", for: indexPath) as! ProfileSecondCell
            cell.set(image: setValueFromSecond(at: indexPath, with: cellViewModel).0, attrTextInfo: setValueFromSecond(at: indexPath, with: cellViewModel).1)
            return cell
        case 2:
            guard self.profileViewModel.cell!.canAccessClosed! else {
                let cell = tableView.dequeueReusableCell(withIdentifier: "ClosedProfileCell", for: indexPath) as! ClosedProfileCell
                cell.setDescription(name: self.profileViewModel.cell!.firstName!, sex: self.profileViewModel.cell!.sex!)
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: PhotoProfileCell.reuseId, for: indexPath) as! PhotoProfileCell
            guard photosViewModel.cell.count > 0 else { return UITableViewCell() }
            cell.set(viewModel: photosViewModel.cell[indexPath.row])
            return cell
        case 3:
            let cell = tableView.dequeueReusableCell(withIdentifier: NewsFeedCell.reuseId, for: indexPath) as! NewsFeedCell
            let cellViewModel = wallViewModel.cells[indexPath.row]
            cell.set(viewModel: cellViewModel)
            cell.transition(.fadeOut, .scale(0.75))
            cell.delegate = self
            return cell
        default:
            return UITableViewCell()
        }
    }
    
//    func tableView(_ tableView: UITableView, willDisplay cell: UITableViewCell, forRowAt indexPath: IndexPath) {
//        let animation = AnimationFactory.makeMoveUpWithFade(rowHeight: cell.frame.height, duration: 0.5, delayFactor: 0.05)
//        let animator = Animator(animation: animation)
//        animator.animate(cell: cell, at: indexPath, in: tableView)
//    }

    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        switch indexPath.section {
        case 0:
            return UITableView.automaticDimension
        case 1:
            return 32
        case 2:
            return photosViewModel.cell.count > 0 ? UITableView.automaticDimension : 0
        case 3:
            let cellViewModel = wallViewModel.cells[indexPath.row]
            return cellViewModel.sizes.totalHeight
        default:
            return 0
        }
    }
    
    func tableView(_ tableView: UITableView, estimatedHeightForRowAt indexPath: IndexPath) -> CGFloat {
        switch indexPath.section {
        case 0:
            return UITableView.automaticDimension
        case 1:
            return 32
        case 2:
            return photosViewModel.cell.count > 0 ? UITableView.automaticDimension : 0
        case 3:
            let cellViewModel = wallViewModel.cells[indexPath.row]
            return cellViewModel.sizes.totalHeight
        default:
            return 0
        }
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(origin: .zero, size: CGSize(width: screenWidth, height: 0.4)))
        view.backgroundColor = .adaptableWhite
        let divider = UIView()
        view.addSubview(divider)
        divider.autoPinEdge(.top, to: .top, of: view)
        divider.autoPinEdge(.leading, to: .leading, of: view, withOffset: 12)
        divider.autoPinEdge(.trailing, to: .trailing, of: view, withOffset: -12)
        divider.autoSetDimension(.height, toSize: 0.4, relation: .equal)
        divider.backgroundColor = .adaptableWhite
        return view
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return section == 2 ? 6 : 0
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 4
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        guard let cellViewModel = profileViewModel.cell else { return }
        if cellViewModel.isCurrentProfile {
            switch indexPath.row {
            case 0 where cellViewModel.followersCount != nil:
                presentPanModal(FollowersViewController(userId: userId))
            default:
                break
            }
        } else {
            switch indexPath.row {
            case 0 where cellViewModel.friendsCount != nil :
                presentPanModal(FollowersViewController(userId: userId))
            default:
                break
            }
        }
    }
    
    func getRowsCount(by viewModel: ProfileCellViewModel) -> Int {
        if viewModel.isCurrentProfile {
            return (viewModel.followersCount) != nil ? 4 : 3
        } else {
            if viewModel.school != nil && viewModel.work != nil {
                return 4
            } else if viewModel.school != nil || viewModel.work != nil {
                return 3
            } else {
                return 2
            }
        }
    }
    
    func setValueFromSecond(at indexPath: IndexPath, with viewModel: ProfileCellViewModel) -> (UIImage?, NSAttributedString) {
        var schoolAttributedText: NSAttributedString
        if let school = viewModel.school {
            schoolAttributedText = NSAttributedString(string: "Место учёбы: \(school)", attributes: [.font: GoogleSansFont.regular(with: 15), .foregroundColor: UIColor.adaptableDarkGrayVK])
        } else {
            schoolAttributedText =  NSAttributedString(string: "Укажите место учебы", attributes: [.font: GoogleSansFont.medium(with: 15), .foregroundColor: UIColor.adaptableBlue])
        }
        
        var workAttributedText: NSAttributedString
        if let work = viewModel.work {
            workAttributedText = NSAttributedString(string: "Место работы: \(work)", attributes: [.font: GoogleSansFont.medium(with: 15), .foregroundColor: UIColor.adaptableDarkGrayVK])
        } else {
            workAttributedText = NSAttributedString(string: "Укажите место работы", attributes: [.font: GoogleSansFont.medium(with: 15), .foregroundColor: UIColor.adaptableBlue])
        }
        if viewModel.isCurrentProfile {
            switch indexPath.row {
            case 0 where viewModel.followersCount != nil:
                return (UIImage(named: "followers_outline_20")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableDarkGrayVK), NSAttributedString(string: "\(viewModel.followersCount!) \(getStringByDeclension(number: viewModel.followersCount!, arrayWords: Localization.instance.followersString))", attributes: [.font: GoogleSansFont.medium(with: 15), .foregroundColor: UIColor.adaptableDarkGrayVK]))
            case 0 where viewModel.followersCount == nil, 1 where viewModel.followersCount != nil:
                return (UIImage(named: "education_outline_20")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), schoolAttributedText)
            case 1 where viewModel.followersCount == nil, 2 where viewModel.followersCount != nil:
                return (UIImage(named: "work_outline_20")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), workAttributedText)
            case 2 where viewModel.followersCount == nil, 3 where viewModel.followersCount != nil:
                return (UIImage(named: "info_20 @ about")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), NSAttributedString(string: "Подробная информация", attributes: [.font: GoogleSansFont.medium(with: 16), .foregroundColor: UIColor.adaptableBlue]))
            default:
                return (nil, NSAttributedString(string: ""))
            }
        } else {
            switch indexPath.row {
            case 0:
                return (UIImage(named: "user_outline_20")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableDarkGrayVK), NSAttributedString(string: "\(viewModel.friendsCount!) \(getStringByDeclension(number: viewModel.friendsCount!, arrayWords: Localization.instance.friendsCount))", attributes: [.font: GoogleSansFont.medium(with: 15), .foregroundColor: UIColor.adaptableDarkGrayVK]))
            case 1:
                if viewModel.school != nil {
                    return (UIImage(named: "education_outline_20")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableDarkGrayVK), schoolAttributedText)
                } else if viewModel.school == nil && viewModel.work != nil {
                    return (UIImage(named: "work_outline_20")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableDarkGrayVK), workAttributedText)
                } else {
                    return (UIImage(named: "info_20 @ about")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), NSAttributedString(string: "Подробная информация", attributes: [.font: GoogleSansFont.medium(with: 16), .foregroundColor: UIColor.adaptableBlue]))
                }
            case 2:
                if viewModel.school != nil && viewModel.work != nil {
                    return (UIImage(named: "work_outline_20")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableDarkGrayVK), workAttributedText)
                } else {
                    return (UIImage(named: "info_20 @ about")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), NSAttributedString(string: "Подробная информация", attributes: [.font: GoogleSansFont.medium(with: 16), .foregroundColor: UIColor.adaptableBlue]))
                }
            case 3:
                return (UIImage(named: "info_20 @ about")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), NSAttributedString(string: "Подробная информация", attributes: [.font: GoogleSansFont.medium(with: 16), .foregroundColor: UIColor.adaptableBlue]))
            default:
                return (nil, NSAttributedString(string: ""))
            }
        }
    }
    
    func openPhoto(for cell: NewsFeedCell, with url: String?) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        guard let selectedCell = mainTable.cellForRow(at: indexPath) as? NewsFeedCell else { return }
        guard let image = selectedCell.postImageView.image else { return }
        let slideLeafs = [SlideLeaf(image: image, imageUrlString: wallViewModel.cells[indexPath.row].photoAttachements.first?.photoMaxUrl, title: "Фотография 1 из 1", caption: "")]

        let slideImageViewController = SlideLeafViewController.make(leafs: slideLeafs, startIndex: indexPath.item, fromImageView: selectedCell.postImageView)
        slideImageViewController.modalPresentationStyle = .fullScreen
        present(slideImageViewController, animated: true)
    }
    
    func onOpenPhoto(for cell: ProfileFristCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        guard let selectedCell = mainTable.cellForRow(at: indexPath) as? ProfileFristCell else { return }
        guard let image = selectedCell.avatarImageView.image else { return }
        let slideLeafs = [SlideLeaf(image: image, imageUrlString: profileViewModel.cell?.photoMaxOrig, title: "Фотография 1 из 1", caption: "")]

        let slideImageViewController = SlideLeafViewController.make(leafs: slideLeafs, startIndex: indexPath.item, fromImageView: selectedCell.avatarImageView)
        slideImageViewController.modalPresentationStyle = .fullScreen
        present(slideImageViewController, animated: true)
    }
    
    func onOpenPhotoAnother(for cell: ProfileFirstAnotherCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        guard let selectedCell = mainTable.cellForRow(at: indexPath) as? ProfileFirstAnotherCell else { return }
        guard let image = selectedCell.avatarImageView.image else { return }
        let slideLeafs = [SlideLeaf(image: image, imageUrlString: profileViewModel.cell?.photoMaxOrig, title: "Фотография 1 из 1", caption: "")]

        let slideImageViewController = SlideLeafViewController.make(leafs: slideLeafs, startIndex: indexPath.item, fromImageView: selectedCell.avatarImageView)
        slideImageViewController.modalPresentationStyle = .fullScreen
        present(slideImageViewController, animated: true)
    }
}
